Subject: Re: TCP end-to-end Semantics

From: [email-masked]
Date: Wed, 10 Jan 2001 09:18:06 +0530

Hi,

The requirement is that a TCP session, once it starts in spoofed mode continues
thenceforth
in spoofing mode unless there is a graceful closure. A route change that causes
one of the
spoofers to be removed from the path, will not be tolerated by most spoofers
that I know of.
However, this isn't as severe a restriction as it sounds.....most spoofers that
I know operate
on access networks where there is only one point of attachment.

It would be interesting if there has been any study on spoofers that do tolerate
these route
changes. What about snoopers, or soft-state spoofers? Do they suffer from the
same problem?

-very best regards,
Abheek

[email-masked] wrote:
>
> Can somebody come up with some examples of practical, relevant applications
> that will fail under spoofing?

What about any connection whose spoofed ACKs cause the sender's window to
reuse offsets (i.e., roll-around), and then has a change in the
path that causes the spoofer (with its state) to be outside the path?

The result will _look_ like a successful transfer, but result
in corruption.

Joe

---

From: Manish Karir <[email-masked]>
Date: Wed, 10 Jan 2001 10:01:33 -0500 (EST)

You can check out:
http://www.isr.umd.edu/TechReports/CSHCN/1999/CSHCN_TR_99-11/CSHCN_TR_99-11.pdf

I believe this implementation had a way of maintaining seq numbers
such that they would work even if some traffic was 
routed around the spoofer. but I'm not sure....

Maybe if the original authors are still on this list they can comment...

manish

On Wed, 10 Jan 2001 [email-masked] wrote:

> Hi,
> 
> The requirement is that a TCP session, once it starts in spoofed mode
> continues thenceforth in spoofing mode unless there is a graceful
> closure. A route change that causes one of the spoofers to be removed
> from the path, will not be tolerated by most spoofers that I know of.
> However, this isn't as severe a restriction as it sounds.....most
> spoofers that I know operate on access networks where there is only
> one point of attachment.
> 
> It would be interesting if there has been any study on spoofers that
> do tolerate these route changes. What about snoopers, or soft-state
> spoofers? Do they suffer from the same problem?
> 
> -very best regards,
> Abheek

---

From: Joe Touch <[email-masked]>
Date: Wed, 10 Jan 2001 10:57:49 -0800

> routed around the spoofer. but I'm not sure....

It appears to assert that it preserves E2E semantics by preserving
the sequence numbers. 

However the source TCP has no way of knowing that this
intermediate has correctly or consistently provided that
guarantee (or the one about delaying the SYN-ACK until
it comes from the source, e.g.).

> > spoofers that I know operate on access networks where there is only

The reason this is of further concern is that the spoofer code can
die, in which case the TCP connection should show an error. As
I pointed out before, this would result in erroneous data being
transferred instead.

The key point of the E2E argument is that it does not allow
adding intermediate components except for performance, 
exactly because the E2E communication depends critically
on their correct operation. Unless there is a provably
uncrashable spoofer, it clearly violates TCP's E2E semantics
as a result.

Joe